from OpenGL.GLUT import *
from OpenGL.GL import *
from OpenGL.Tk import *
from string import *

initial_width = 400           # Initial Window Width = 400 pixels
initial_height = 400    # Initial Window Height = 400 pixels

xmin= -1
xmax = 1
ymin = -1
ymax = 1
zmin = -1
zmax = 1

def bitmap_output(x, y, z, string, font):
#def bitmap_output(x,y,z,string):
   glRasterPos3f(x, y, 0);         # Locate Raster Position in 3-space
   strlen = len(string);              # Find length of string
   for i in range (0, strlen):      # Loop through plotting all characters in font style
       glutBitmapCharacter(font, ord(string[i]));

# Draw a graph of a simple line.

def DrawGraph():
   glBegin(GL_POINTS)                   # Start drawing points
   glColor3f(0.0,0.0,0.0)               # Set drawing color to black
   x = -0.9
   while x < 0.9:
     glVertex3f(x,x,0.0)                # Put a point at (x,x)
     x += 0.01                          # Step through x values 
   glEnd()
   

# Draw a set of labeled axes

def DrawAxes():
    glBegin(GL_LINES)                        # Start Drawing Lines
    glColor3f(1.0, 1.0, 0.0)                 # Set Drawing Color
    glVertex3f(-0.9,0.0, 0.0)                # Starting Point for x-axis
    glVertex3f(0.9, 0.0, 0.0)                # Ending Point
    glVertex3f(0.0, -0.9,0.0)                # Staring Point for y-axiz
    glVertex3f(0.0, 0.9, 0.0)                # Ending Point
    glEnd()
 
  # Now label the axes
    glPushMatrix()                           # New frame of reference
    glTranslatef(0.05, 0.85, 0)              # Move to new location
    bitmap_output(0,0,0, "y", GLUT_BITMAP_TIMES_ROMAN_24)
    glPopMatrix()                              # Return to old reference

    glPushMatrix()                           # New frame of reference
    glTranslatef(0.8, -0.1, 0)               # Move to new location
    bitmap_output(0,0,0, "x", GLUT_BITMAP_TIMES_ROMAN_24)
    glPopMatrix()                              # Return to old reference

# Draw some titles on the screen in available Times Roman fonts

def DrawTitles():
   glColor3f(0.0, 0.0, 0.0)                   # Set color to Black
   glPushMatrix()                             # New frame of reference
   glTranslatef(-0.9, 1.5, 0)                 # Move to new location
   bitmap_output(0,0,0, "Example #1", GLUT_BITMAP_TIMES_ROMAN_24)
   glPopMatrix()                              # Return to old reference

   glPushMatrix()                             # New frame of reference
   glTranslatef(-0.5, -1.25, 0)               # Move to new location
   bitmap_output(0,0,0, "The above graph is for the linear equation   y = x", 
                GLUT_BITMAP_TIMES_ROMAN_10)
   glPopMatrix()                              # Reurn to old reference
 

# Display window

def display1(o):
   glClearColor(1.0, 0.0, 0.0, 1.0)          # Set drawing color to red
   glClear(GL_COLOR_BUFFER_BIT)
   glDisable(GL_LIGHTING)
   DrawAxes()                                 
   DrawGraph()
   DrawTitles()
   glEnable(GL_LIGHTING)
   glFlush()                                  # Force all drawing

def init():
  # select clearing (background) color   
   glClearColor(1.0, 0.0, 0.0, 0.0)

  # initialize viewing values 
   glMatrixMode(GL_PROJECTION)
   glLoadIdentity()
   glOrtho(-1.0, 1.0, -1.0, 1.0, -1.0, 1.0)

 
#
#def display(o):
#	glClearColor(0.5, 0.5, 0.5, 0)
#	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT)
#	glOrtho(xmin, xmax, ymin, ymax, zmin, zmax)
#	glDisable(GL_LIGHTING)
#	DrawAxis()
#	DrawMyStuff()
#	glEnable(GL_LIGHTING)

init()
o = Opengl(width = 400, height = 400, double = 1)
o.init = init
o.redraw = display1
o.pack(side = 'top', expand = 1, fill = 'both')
o.mainloop()
